//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int    Periods          = 14;
extern int    UpperPrice       = PRICE_HIGH;
extern int    LowerPrice       = PRICE_LOW;
extern double Power            = 2;
extern double Deviation        = 0.2;

//
//
//
//
//

double UpH[];
double DnH[]; 
double smax[];
double smin[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0,UpH); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,DnH); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,smax);
      SetIndexBuffer(3,smin);
      SetIndexBuffer(4,trend);
      
         Periods   = MathMax(Periods,1);
         Deviation = MathMax(MathMin(Deviation,100),0.0);
         
 
   IndicatorShortName("Parabolic wma envelopes ("+Periods+")");
   return(0);
}
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
      for(i=limit; i>=0; i--)
      { 
         smax[i]  = (1+Deviation/100)*iLwmp(iMA(NULL,0,1,0,MODE_SMA,UpperPrice,i),Periods,Power,i,0);
         smin[i]  = (1-Deviation/100)*iLwmp(iMA(NULL,0,1,0,MODE_SMA,LowerPrice,i),Periods,Power,i,1);
         UpH[i]   = EMPTY_VALUE;
         DnH[i]   = EMPTY_VALUE;
         trend[i] = trend[i+1]; 
   
         //
         //
         //
         //
         //
         
	      if (Close[i] > smax[i+1]) trend[i] =  1;
         if (Close[i] < smin[i+1]) trend[i] = -1;
	      if (trend[i] > 0 && smin[i] < smin[i+1]) smin[i] = smin[i+1];
	      if (trend[i] < 0 && smax[i] > smax[i+1]) smax[i] = smax[i+1];
         if (trend[i] == 1) UpH[i] = 1;
         if (trend[i] ==-1) DnH[i] = 1;
      }
   
      return(0);
   }
   
   //
   //
   //
   //
   //
   

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double workPrices[][2];
double iLwmp(double price, double period, double power, int i,int forInstance=0)
{
   if (ArrayRange(workPrices,0)!= Bars) ArrayResize(workPrices,Bars);
   int r = Bars-i-1;
   
   //
   //
   //
   //
   //
   
   workPrices[r][forInstance] = price;
      double sum  = 0;
      double sumw = 0;

      for(int k=0; k<period && (r-k)>=0; k++)
      {
         double weight = MathPow((period-k),power);
                sumw  += weight;
                sum   += weight*workPrices[r-k][forInstance];  
      }             
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}